/*
	ControlModule.c Ver.2.1

						2015.7.13 M.Ustumi@ARCDEVICE
*/

#ifndef CONTROL_MODULE_H
#define CONTROL_MODULE_H

#include"SC02.h"
#include"ESPIx.h"
#include"USB.h"

#define CM_MASTER_ID		0xFF

#define CM_OPEN 			0
#define CM_CLOSE 			1
#define CM_RESET 			2
#define CM_PING				3
#define CM_SET_ID 			4
#define CM_GET_ID	 		5
#define CM_GET_VER 			6
#define CM_BLINK 			7
#define CM_TRANSFER 		8
#define CM_SET_PARAM 		9
#define CM_GET_PARAM 		10

#define CM_NORMAL			100
#define CM_NAK				101
#define CM_CTRL_TIMEOUT		102

#define CM_COMMAND_ERROR		110
#define CM_COMMAND_UNDEFINED	110
#define CM_COMMAND_TX_TIMEOUT	111		
#define CM_COMMAND_RX_TIMEOUT	112		
#define CM_COMMAND_SUM_ERROR	113		

#define CM_REPLY_ERROR			120
#define CM_REPLY_NO				120
#define CM_REPLY_TX_TIMEOUT		121
#define CM_REPLY_RX_TIMEOUT		122
#define CM_REPLY_SUM_ERROR		123

#define CM_TRANSFER_ERROR		130
#define CM_TRANSFER_TX_TIMEOUT	131
#define CM_TRANSFER_RX_TIMEOUT	132
#define CM_TRANSFER_SUM_ERROR	133

#define CM_TEST_STATE			200

#define ACK					0x55 // 85
#define NAK					0xAA // 170

typedef struct _CM_PARAM
{
	float dt;			// 䃋[v̎[sec]
	float fCtrlTimeout;	// ̃^CAEg[sec] 0Ł
	float fComTimeout;	// ʐM̃^CAEg[sec] 0Ł
} CM_PARAM, *PCM_PARAM;

typedef struct _TR_HEADER
{
	BYTE	bPort;
	BYTE	bID;
	WORD	wTxSize;
	WORD	wRxSize;
} TR_HEADER, *PTR_HEADER;


extern volatile BYTE CM_bID;
extern BYTE CM_bVersion; 
extern BYTE CM_bStatus; 
extern BYTE CM_bCtrlStatus; 
extern volatile WORD CM_wTimeCount;
extern volatile WORD CM_wCtrlTimeout;	//  ^CAEg

void CM_Init( void );

void CM_Ping( void ); 
void CM_SetID( void );
void CM_GetID( void );
void CM_GetVer( void );
void CM_Blink( void );
void CM_Transfer( void );
void CM_SetParam( void );
void CM_GetParam( void );
void CM_Reply( void );

#endif

