/*
	Main.c SC02 Control Program Ver.2.1

						2015.7.17 M.Ustumi@ARCDEVICE

*/

#include"stdio.h"
#include"ControlModule.h"

/******************************************************************

 ^C}
 ̓^C}1ōC̊荞݂UT_ControlTrigTRUEɂD
 C䃋[`UT_ControlTrigTRUEɂȂ܂ő҂̏sD
 UT_ControlTrig̓C䃋[`FALSEɂD

******************************************************************/

void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt( void )
{
	IFS0bits.T1IF = 0;

	UT_ControlTrig = TRUE;

	if( USB_wTimeout > 0 ) USB_wTimeoutCount++;
	if( ESPI1_wTimeout > 0 ) ESPI1_wTimeoutCount++;

}


void ProcCommand( void )
{
	BYTE bCommand;

	if(!USB_Read( &bCommand, 1 )){
		CM_bStatus = CM_COMMAND_RX_TIMEOUT;
		return;
	}

	switch(bCommand){
	case CM_RESET: 		CM_Reset(); break;
	case CM_PING: 		CM_Ping(); break;
	case CM_SET_ID: 	CM_SetID();	break;
	case CM_GET_ID: 	CM_GetID(); break;
	case CM_GET_VER: 	CM_GetVer(); break;
	case CM_BLINK: 		CM_Blink(); break;
	case CM_TRANSFER: 	CM_Transfer(); break;
	case CM_SET_PARAM: 	CM_SetParam(); break;
	case CM_GET_PARAM: 	CM_GetParam(); break;
	default:
		CM_bStatus = CM_COMMAND_UNDEFINED;
	}
}

void ProcStatus( void )
{
	switch( CM_bStatus ){
	case CM_NORMAL: UT_StatusBlink(1000, 1, 1 ); break;
	case CM_COMMAND_UNDEFINED: UT_StatusBlink(250, 1, 3 ); break;
	case CM_COMMAND_RX_TIMEOUT: UT_StatusBlink(250, 2, 3 ); break;	
	case CM_COMMAND_SUM_ERROR: UT_StatusBlink(250, 3, 3 );  break;
	case CM_REPLY_TX_TIMEOUT: UT_StatusBlink(250, 4, 3 ); break;	
	case CM_TRANSFER_ERROR:
	case CM_REPLY_ERROR+ESPI_SCK_HUNGUP:
	case CM_COMMAND_ERROR+ESPI_SCK_HUNGUP: UT_StatusBlink( 250, 5, 3); break;
	case CM_REPLY_ERROR+ESPI_CS_HUNGUP:
	case CM_COMMAND_ERROR+ESPI_CS_HUNGUP: UT_StatusBlink( 250, 6, 3); break;
	//case UT_TEST_STATE: UT_StatusBlink( 250, 3, 4); break;
	}
}

int main(void)
{
	CM_Init();// ݒƃ^C}Jn

	UT_StatusBlink( 250, 3, 2);

	while(1){
		if( USB_DataReady() ){
			ProcCommand();
			UT_StatusBlink( 25, 1, 2 );
		}

		if( UT_ControlTrig ){
			//@̐䏈͂ɋLq
		
			ProcStatus();

			UT_ControlTrig = FALSE;
		}
	}

}

