/****************************************************************

	USB functions for FT245( SC01&SC02 )

					2015.7.28 M.Utsumi@ARCDEVICE
*****************************************************************/

#include"USB.h"

WORD USB_wTimeout; 
volatile WORD USB_wTimeoutCount;

#define USB_TX_BUF_SIZE	256
BYTE bTxBuffer[ USB_TX_BUF_SIZE ];
BYTE* pbTxBuffer;
WORD wTxBufCount;

void USB_Open( void )
{
	USB_RD = 1;
	USB_WR = 1;
	TRIS_RD = 0;
	TRIS_WR = 0;

	BUS_SetInput();

	UT_ZeroMemory( bTxBuffer, USB_TX_BUF_SIZE  );

	USB_wTimeout = 0;
	USB_wTimeoutCount = 0;

	pbTxBuffer = bTxBuffer;
	wTxBufCount=0;
}

void USB_InitTxBuffer( void )
{
	pbTxBuffer = bTxBuffer;
	wTxBufCount=0;
}

void USB_SetTimeout( WORD wTimeout_ms )
{
	USB_wTimeout = wTimeout_ms;
}
 
BOOL USB_Read( BYTE* pBuffer, WORD wSize  )
{
	BUS_SetInput();

	while(wSize--){
		USB_wTimeoutCount = 0;
		while(RXF){
			if( USB_wTimeoutCount > USB_wTimeout  ) return( FALSE );
		}
		USB_RD = 0;
		Nop();
		Nop();
		*pBuffer++ = BUS_Input();
		USB_RD = 1;
	}
	return(TRUE);
}

BOOL USB_Write( BYTE* pBuffer, WORD wSize )
{
	BUS_SetOutput();

	while(wSize--){
		USB_wTimeoutCount = 0;

		while(TXE){
			if( USB_wTimeoutCount > USB_wTimeout  ) return( FALSE );
		}
		USB_WR = 1;
		BUS_Output( *pBuffer++ );
		USB_WR = 0;
	}
	USB_WR = 1;
	return(TRUE);
}

BOOL USB_WriteBuf( BYTE* pbBuffer, WORD wSize )
{
	while( wSize-->0){
		*pbTxBuffer++ = *pbBuffer++;
		wTxBufCount++;
	}
	return( TRUE );
}

BOOL USB_Reply( void )
{
	if( !USB_Write( bTxBuffer, wTxBufCount ) ) return( FALSE );

	wTxBufCount = 0;
	pbTxBuffer = bTxBuffer;

	return( TRUE );	
}

void USB_ClearRxFIFOBuffer( void )
{
	BUS_SetInput();

	while(!RXF){
		USB_RD = 0;
		Nop();
		Nop();
		USB_RD = 1;
	}
}


